-- BeneCast by Wintrow

-- Props to Skurel's original BeneCast
-- This version is nearly completely rebuilt and rewritten though
-- Makes clickable buttons that casts beneficial spells on party members and the current target

BeneCast = LibStub("AceAddon-3.0"):NewAddon("BeneCast","AceConsole-3.0","AceEvent-3.0");

BeneCast.Constants = {
	Version = 10.0, -- This is used to reset the configuration if severely outdated
	Targets = { 'player', 'party1', 'party2', 'party3', 'party4', 'pet', 'partypet1', 'partypet2', 'partypet3', 'partypet4', 'target', 'targettarget', 'focus' },
	TypesSorted = { 'rez', 'brez', 'heal', 'hot', 'buff', 'cure', 'stance' },
};
BeneCast.WorkVars = {
	PlayerClass = '',
	AttachedTargets = {}, -- Array to hold the list of targets we are currently attached to
	BuffsInEffect = {},
	ButtonsBySpell = {},
	ButtonsThatFlash = {},
	LastRangeCheck = nil,
	UnitsToUpdate = {},
	ShadowFormBuffID = nil,
	ConsiderInCombat = false,
	SpellData = {},
	ToTData = {},
	Panels = {},
	OldButtons = {},
};
BeneCast.Panel = {
	unit = nil,
	pf = nil,
};
BeneCast.Button = {
	NormalTexture = nil,
	Cooldown = nil,
	Fade = nil,
	Range = nil,
	Duration = nil,
	unit = nil,
	pf = nil,
	seqno = nil,
};
BeneCast.SnapTo = {};
BeneCast.db = {};

local wv = BeneCast.WorkVars;

local options = {
    name = "BeneCast",
    handler = BeneCast,
    type = 'group',
    args = {
        msg = {
            type = 'input',
            name = 'My Message',
            desc = 'The message for my addon',
            set = 'SetMyMessage',
            get = 'GetMyMessage',
        },
    },
};
